from pydantic import BaseSettings
from typing import Optional
import os

from pydantic.fields import T


class Settings(BaseSettings):
    app_name: str = "Kingsome API"
    admin_email: str = "pengtao@kingsome.cn"
    items_per_user: int = 50
    is_debug: bool = True

    MONGODB_URL = "mongodb://admin:kingsome@localhost"
    platform_url = "https://switch.jumpvg.com/jump/platform/order/v2?needCount=1&needFilter=1&version=3"
    all_game_url = "https://switch.jumpvg.com/jump/findGame/list?categoryList=&featureList=&limit=10&offset={offset}&platForm={platformid}&systemList=&type=4&version=3"
    game_info_url = "https://switch.jumpvg.com/jump/game/detail?clickFrom=-1&id={gameid}&path=find_discount_gamedetail_switch&platform={platformid}&version=3"
    game_price_url = "https://switch.jumpvg.com/jump/price/getAllPriceByGame?id={gameid}&platform={platformid}"
    game_history_price_url = "https://switch.jumpvg.com/switch/getDiscount?appid={gameid}&platform={platformid}&zone=all"

    x_token: str = "abc"

    root_path_in_servers: Optional[bool] = False
    root_path: str = '/api/v1'

    origins: list = [
        "http://*.kingsome.cn",
        "https://*.kingsome.cn",
        "http://localhost",
        "http://localhost:8080",
    ]


settings = Settings()
