from fastapi import APIRouter, BackgroundTasks, UploadFile, File, Form
from typing import List
from pydantic import BaseModel
from starlette.requests import Request
from starlette.responses import JSONResponse
from config.config import settings
from scripts.sync_data import get_jump_data

router = APIRouter()


@router.get("/sync_data")
async def get_lists(request: Request) -> bool:
    db = request.app.state.mongo
    await get_jump_data(db)
    return True


@router.get("/get_list")
async def get_lists(request: Request, keys: str) -> JSONResponse:
    return {"url": keys}


@router.get("/get_allprice")
async def get_allprice(request: Request, keys: str) -> JSONResponse:
    return {"url": keys}


@router.get("/get_gameinfo")
async def get_gameinfo(request: Request, id: int) -> JSONResponse:
    return {"url": 'keys'}